//********************************************************************
//  Point.java
//
//  3 ǥ   Ÿ Ŭ Point
//********************************************************************

package kr.pwj.coord3D;

import java.util.Scanner;

public class Point 
{
    private int x, y, z;
    
    public Point(int x, int y, int z) 
    {
        this.x = x;
        this.y = y;
        this.z = z;
    }
    public String toString() 
    {
        String buf = "(" + x + ", " + y + ", " + z + ")";
        return buf;
    }
    public int getX() 
    {
        return x;
    }
    public int getY()
    {
        return y;
    }
    public int getZ() 
    {
        return z;
    }
    public static Point readPoint(Scanner scan, String prompt) 
    {
        int x, y, z;
        System.out.print(prompt + " ");
        x = scan.nextInt();
        y = scan.nextInt();
        z = scan.nextInt();
        Point p = new Point(x, y, z);
        return p;
    }
    public double distanceFrom(Point q) 
    {
        double dist = Math.sqrt(Math.pow(q.x - x, 2) 
                              + Math.pow(q.y - y, 2)
                              + Math.pow(q.z - z, 2));
        return dist;
    }
}
