/***********************************************************
* TrafficLightChange.java
*
* ٲ ȣ ÷ ϴ α׷
***********************************************************/

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
*  ϰ ȣ г ߰Ѵ. 
*/ 
public class TrafficLightChange
{
   public static void main (String[] args)
   {
      JFrame frame = new JFrame ("Traffic Light");
      frame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);

      frame.getContentPane().add(new LightChangePanel());

      frame.pack();
      frame.setVisible(true);
   }
}

/**
* ٲ ȣ ϴ г
*/
class LightChangePanel extends JPanel
{
	private boolean green, yellow, red;
	private Timer t;

   /**
   * : г ũ  ϰ Ÿ̸Ӹ ۽Ų.
   */
   public LightChangePanel()
   {
      setPreferredSize (new Dimension(300, 200));
      setBackground (Color.black);
	  green = true;
	  t = new Timer(5000, new ClockListener());
      t.start();
   }

   /**
   * , ,  ȣ ׸. 
   */
   public void paintComponent(Graphics page)
   {
        super.paintComponent(page);
	
        if (red) {
            page.setColor(Color.red);		
            page.fillOval(50,50,40,40);
        }

        if (yellow) {
            page.setColor(Color.yellow);		
            page.fillOval(100,50,40,40);
        }

        if (green) {
            page.setColor(Color.green);
            page.fillOval(150,50,40,40);
        }
   }

    /**
    * ȣ  ϰ ÷ Ѵ.
    */    
    private class ClockListener implements ActionListener 
    {
        public void actionPerformed(ActionEvent e) 
	    {
            if (green) {
                yellow = true;
                green = false;
            } 
            else if (yellow) {
                red = true;
                yellow = false;
            } 
            else if (red) {
                green = true;
                red = false;
            }

            repaint();
        }
    }
}