/************************************************************
 * DrawRectangles.java
 * 
 * ׷Ƚ ׸   ׸ ø
 ************************************************************/

import javax.swing.JApplet;
import java.awt.Graphics;
	
/** 
 * ׸   ׸  Ŭ DrawRectangles.
 * ʺ WIDTH ̰ HEIGHT ȭ(׷ ؽƮ) 
 * NUM_OF_RECTS  ׸ øϿ ׸.
 */
public class DrawRectangles extends JApplet 
{
    private static final long serialVersionUID = 1L;
    private static final int WIDTH = 256, HEIGHT = 256;
    private static final int NUM_OF_RECTS = 20;
 
    public void init() 
    {
        resize(WIDTH, HEIGHT);
    }
    public void paint(Graphics g) 
    {
        drawRects(g);
    }
    protected void drawRects(Graphics g) 
    {
        int dx = WIDTH / 2 / NUM_OF_RECTS;
        int dy = HEIGHT / 2 / NUM_OF_RECTS;
        int x = dx, y = dy;
        int w = WIDTH - 2 * dx;
        int h = HEIGHT - 2 * dy;
        for (int i = 0; i < NUM_OF_RECTS; ++i) {
            g.drawRect(x, y, w, h);
            x += dx; y += dy;
            w -= 2 * dx; h -= 2 * dy;
        }
    }
}
