/************************************************************
 * ShowImage.java
 * 
 * ׷Ƚ ̹ ׸ ø.
 * ̹ ũ⿡  ø ũ⸦ Ѵ.
 ************************************************************/

import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.ImageObserver;
import javax.swing.JApplet;

/** 
 * ׷Ƚ ̹ ׸  Ŭ ShowImage.
 * getWidth(), getHeight() ޼ҵ  ImageObserver ̿Ͽ
 * ̹ ü ũ  ø ũ⸦ Ѵ. 
 */
public class ShowImage extends JApplet implements ImageObserver
{
    private static final long serialVersionUID = 1L;
    private Image image;
    private int width = 0, height = 0;

    public void init() 
    {
        image = getImage(getDocumentBase(),"javabook.jpg");
        width = image.getWidth(this);
        height = image.getHeight(this);
        if (width > 0 && height > 0)
        	resize(width, height);
    }
    public void paint(Graphics g) 
    {
        g.drawImage(image, 0, 0, this);
    }
    public boolean imageUpdate(Image i, int fs, int x, int y, int w, int h) 
    {
        if (fs != ImageObserver.ALLBITS) {
//        	System.out.printf("bits = %X%n", fs);
//        	System.out.printf("w = %d%n", w);
//        	System.out.printf("h = %d%n", h);
            return true;
        }
        else {
            width = (w > width)? w: width;
            height = (h > height)? h: height;
//        	System.out.printf("width = %d%n", width);
//        	System.out.printf("height = %d%n", height);
            this.resize(width, height);
            this.repaint();
            return false;
        }
    }
}
