/************************************************************
* ViewFile.java
*
*   α׷
************************************************************/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;

/**
* ؽƮ  ̿Ͽ   ֱ 
*/
public class ViewFile 
{
    public static void main(String[] args) 
    {
        JFrame window = new JFrame(" ");
        window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        window.setContentPane(new ViewFileGUI());
        window.pack();
        window.setVisible(true);
    }
}

/**
*    GUI г ϴ Ŭ
*/
class ViewFileGUI extends JPanel 
{    
    // ؽƮ    
    JTextArea    textArea  = new JTextArea(25, 80);
    JFileChooser fileChooser = new JFileChooser();
    
    /**
    *  :  ư ؽƮ  ϰ ġѴ.
    */
    ViewFileGUI() 
    {
        JButton openButton = new JButton("");
        
        // ư  ߰
        openButton.addActionListener(new OpenAction());
        
        // Ʈ ġ
        this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.add(openButton);
        this.add(new JScrollPane(textArea));
    }
    
    /**
    *  õǸ   о   ÷ϴ  
    */
    class OpenAction implements ActionListener 
    {
        public void actionPerformed(ActionEvent ae) 
        {
            int retval = fileChooser.showOpenDialog(ViewFileGUI.this);

            if (retval == JFileChooser.APPROVE_OPTION) {
                File file = fileChooser.getSelectedFile();
                try {
                    Scanner scan = new Scanner(file);
                    String line;
                    textArea.setText("");

                    //  پ о ؽƮ  ÷
                    while (scan.hasNextLine()) {
                        line = scan.nextLine();
                        textArea.append(line + "\n");
                    }  
                } catch (FileNotFoundException e) {
                    System.out.println(" ");
                }
            }
        }
    }
}