/************************************************************
 * Transaction.java
 * 
 * ¿  ϴ α׷(ùٸ ).
 * Account ޼ҵ  Ϻΰ synchronized ޼ҵ .
 ************************************************************/

/**
 * ¿  ϱ  Transaction Ŭ.
 * Account Ŭ ̿Ͽ ¸  
 *  ¿  ϴ ۾(Ʈ)  ,
 *  ۾ ķ Ѵ.  忡 join() ޼ҵ带
 * ̿Ͽ  Ʈ ⸦ ٸ Ŀ ܾ Ѵ.
 */
public class Transaction implements Runnable 
{
    private Account acc;
    
    public Transaction(Account account) 
    {
        acc = account;
    }
    public void deposit(int amount) 
    {
        for (int i = 0; i < amount; ++i)
            acc.deposit(1);
    }
    public void run() 
    {
        deposit(10000);
    }
    public static void main(String args[]) 
    {
        Account account = new Account();
        System.out.printf("  ܾ = %d%n", account.balance());
        Transaction tr = new Transaction(account);
        Thread thread1 = new Thread(tr);
        thread1.start();
        tr.run();
        try {
            thread1.join();
        } catch (InterruptedException e) {
            System.out.println("ڿ  ߴܵ");
        }
        System.out.printf("  ܾ = %d%n", account.balance());
    }
}

/**
 *  ܾ ϱ  Account Ŭ.
 *  ޼ҵ deposit()  ޼ҵ withdraw(),
 * ܾ ȸϱ   balance() ޼ҵ带 ϰ ִ.
 *   ٸ deposit() withdraw() 
 * synchronized ޼ҵ Ͽ.
 */
class Account 
{
    private int balance;
    
    public Account() 
    {
        balance = 0;
    }
    public synchronized void deposit(int amount) 
    {
        balance += amount;
    }
    public synchronized void withdraw(int amount) 
    {
        balance -= amount;
    }
    public int balance() 
    {
        return balance;
    }
}

