/************************************************************
 * Bakery.java
 * 
 *  ùķ̼ α׷(ùٸ ).
 * ȭ ۸ ϰ ִ.
 ************************************************************/

/**
 *  ùķ̼ϴ Bakery Ŭ. 
 * ũ ڿ ũ Һڰ ۸ ϵ Ͽ. 
 *  ü ȭ ϰ ֱ  ڿ Һ,
 * ڿ , Һڿ Һ ̿
 * ȭ ̷ ִ.
 */
public class Bakery 
{
    public final static int NUM = 3;
    public static enum Cream {NONE, CREAM, SUGAR, HONEY};
    public static String printCream(Cream c) 
    {
        switch (c) {
        case CREAM: return "ũ";
        case SUGAR: return "";
        case HONEY: return "";
        case NONE:
        default: return "";
        }
    }
    public static Cream cream(int i) 
    {
        switch (i % 3) {
        case 0: return Cream.CREAM;
        case 1: return Cream.SUGAR;
        case 2: return Cream.HONEY;
        default: return Cream.NONE;
        }
    }
    public static void main(String args[]) 
    {
        Buffer buffer = new Buffer();
        new Thread(new Producer(buffer)).start();
        new Thread(new Consumer(buffer)).start();
    }
}

/**
 * ũ ϱ  Buffer Ŭ.
 *  ũ ϳ   Ƿ  ũ 1̴.
 *   ޸ ޼ҵ put() get()
 * wait() notify() ̿Ͽ ȭ ϰ ִ.
 */
class Buffer 
{
    private boolean isEmpty = true;
    private Bakery.Cream cream;
    public Buffer()
    {
        this.cream = Bakery.Cream.NONE;
        this.isEmpty = true;
    }
    public synchronized void put(Bakery.Cream cream) 
    {
        if (! isEmpty) {
            try {
                wait();
            }
            catch (InterruptedException e) {
                System.out.println("Buffer.put(): ڿ  ߴܵ");
            }
        }
        this.cream = cream;
        isEmpty = false;
        System.out.println("ũ : " + Bakery.printCream(cream));
        notifyAll();
    }
    public synchronized Bakery.Cream get() 
    {
        if (isEmpty) {
            try {
                wait();
            }
            catch (InterruptedException e) {
                System.out.println("Buffer.get(): ڿ  ߴܵ");
            }
        }
        System.out.println("ũ Һ: " + Bakery.printCream(cream));
        isEmpty = true;
        notifyAll();
        return cream;
    }
}

/**
 * ũ ϴ Producer Ŭ. 
 *   ŭ ۿ ũ Ͽ Ѵ.
 */
class Producer implements Runnable 
{
    Buffer buffer;
    Producer(Buffer buffer) 
    {
        this.buffer = buffer;
    }
    public void run() 
    {
        for (int i = 0; i < Bakery.NUM; ++i) {
            buffer.put(Bakery.cream(i));
        }
    }
}

/**
 * ũ Һϴ Consumer Ŭ. 
 *   ŭ ۷κ ũ ͼ ҺѴ.
 */
class Consumer implements Runnable 
{
    Buffer buffer;
    Consumer(Buffer buffer) 
    {
        this.buffer = buffer;
    }
    public void run() 
    {
        for (int i = 0; i < Bakery.NUM; ++i) {
            System.out.println(" : "+Bakery.printCream(buffer.get())+"");
        }
    }
}
