/**
 * Point.java
 *
 * 2 ǥ   Ÿ Ŭ Point
 *    Ÿ ϴ distanceFrom ޼ҵ带  
 */

package kr.pwj.coord2D;

import java.util.Scanner;

public class Point {
    private int x, y;

    public Point(int x, int y)
    {
        this.x = x;
        this.y = y;
    }
    public String toString()
    {
        String buf = "(" + x + ", " + y + ")";
        return buf;
    }
    public int getX()
    {
        return x;
    }
    public int getY()
    {
        return y;
    }
    public double distanceFrom(Point q) {
        double dist = Math.sqrt(Math.pow(q.x - x, 2) 
                              + Math.pow(q.y - y, 2));
        return dist;
    }
    public static Point readPoint(Scanner scan, String prompt) {
        int x, y;
        System.out.print(prompt + " ");
        x = scan.nextInt();
        y = scan.nextInt();
        Point p = new Point(x, y);
        return p;
    }
}
