/***********************************************************
* PositionPanel.java 
*
* 콺 Ŭ ġ ׸ г α׷
***********************************************************/

import java.awt.*;
import java.awt.Color;
import java.awt.Point;
import java.awt.event.*;
import javax.swing.*;

/** 
* 콺 Ŭ ġ ׸ г Ѵ.
*/
public class PositionPanel extends JPanel
{
    private final int WIDTH=300, HEIGHT=300;
    private Point current;

    /**
    * : , ũ,   Ѵ.  
    */
    public PositionPanel()
    {
        addMouseListener(new PositionListener());
        setPreferredSize(new Dimension(WIDTH, HEIGHT));
        setBackground(Color.yellow);
    }

    /**
    * κ  ׸ ġ ǥѴ. 
    */
    public void paintComponent(Graphics page)
    {
        super.paintComponent(page);
        page.setColor(Color.black);

        if (current != null)
        {
            page.drawLine (current.x, current.y, 0, 0);
            page.drawString("("+current.x+","+current.y+")", current.x, current.y);
        }
    }

    /**
    * 콺 ̺Ʈ  ʸ ۼѴ. 
    */
    private class PositionListener implements MouseListener
    {
        /**
        * 콺 Ŭ õ  ϰ ٽ ׸ Ѵ.
        */
        public void mouseClicked (MouseEvent event)
        {
            current = event.getPoint();
            repaint();
        }

	    public void mousePressed(MouseEvent event)
        {
        }

        public void mouseReleased(MouseEvent event) 
	    {
        }

        public void mouseEntered(MouseEvent event) 
	    {
        }

        public void mouseExited(MouseEvent event) 
	    {
        }
    }
}