/************************************************************
 * DrawLines.java
 * 
 * ׷Ƚ    ׸ ø
 ************************************************************/

import java.awt.Graphics;
import javax.swing.JApplet;

/** 
 * ׷Ƚ  ׸  DrawLines Ŭ.
 * â Apple ǻͿ αִ α׷ Ͽ.
 * ȼ  ׸ ˰  ׳  ׸⸸ ص
 * Ƹٿ ̰ Ÿ.
 */
public class DrawLines extends JApplet 
{
    private static final long serialVersionUID = 1L;
    private static final int HEIGHT = 255, WIDTH = HEIGHT + 126;
 
    public void init() 
    {
        resize(WIDTH, HEIGHT);
    }
    public void paint(Graphics g) 
    {
        drawLines(g, WIDTH/2, HEIGHT/2);
    }
    protected void drawLines(Graphics g, int x, int y) 
    {
        int dx = 3, dy = dx;
        drawLines(g, x, y, 0, 0, dx, 0);
        drawLines(g, x, y, WIDTH, 0, 0, dy);
        drawLines(g, x, y, WIDTH, HEIGHT, -dx, 0);
        drawLines(g, x, y, 0, HEIGHT, 0, -dy);
    }
    protected void drawLines(Graphics g, int x1, int y1, int x2, int y2, int dx, int dy) 
    {
        while (0 <= x2 && x2 <= WIDTH && 0 <= y2 && y2 <= HEIGHT) {
            g.drawLine(x1, y1, x2, y2);
            x2 += dx;
            y2 += dy;
        }
    }
}
